blob: 82bc736532f15e632323b82ae6e4755646fda403 [file] [log] [blame]
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +02001#!/bin/sh
Greg Kroah-Hartmanb2441312017-11-01 15:07:57 +01002# SPDX-License-Identifier: GPL-2.0
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +02003#
4# link vmlinux
5#
Masahiro Yamadad151e972019-01-17 09:10:04 +09006# vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_OBJS) and
7# $(KBUILD_VMLINUX_LIBS). Most are built-in.a files from top-level directories
8# in the kernel tree, others are specified in arch/$(ARCH)/Makefile.
9# $(KBUILD_VMLINUX_LIBS) are archives which are linked conditionally
10# (not within --whole-archive), and do not require symbol indexes added.
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020011#
12# vmlinux
13# ^
14# |
Masahiro Yamadad151e972019-01-17 09:10:04 +090015# +--< $(KBUILD_VMLINUX_OBJS)
16# | +--< init/built-in.a drivers/built-in.a mm/built-in.a + more
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020017# |
Nicholas Piggin3a166fc2017-06-20 01:52:05 +100018# +--< $(KBUILD_VMLINUX_LIBS)
19# | +--< lib/lib.a + more
20# |
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020021# +-< ${kallsymso} (see description in KALLSYMS section)
22#
23# vmlinux version (uname -v) cannot be updated during normal
24# descending-into-subdirs phase since we do not yet know if we need to
25# update vmlinux.
26# Therefore this step is delayed until just before final link of vmlinux.
27#
28# System.map is generated to document addresses of all kernel symbols
29
30# Error out on error
31set -e
32
Masahiro Yamada3ec8a5b2020-07-02 04:29:36 +090033LD="$1"
34KBUILD_LDFLAGS="$2"
35LDFLAGS_vmlinux="$3"
36
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020037# Nice output in kbuild format
38# Will be supressed by "make -s"
39info()
40{
Masahiro Yamadac39013e2021-05-17 16:03:14 +090041 printf " %-7s %s\n" "${1}" "${2}"
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020042}
43
Sami Tolvanena8cccdd2020-12-11 10:46:24 -080044# Generate a linker script to ensure correct ordering of initcalls.
45gen_initcalls()
46{
47 info GEN .tmp_initcalls.lds
48
49 ${PYTHON} ${srctree}/scripts/jobserver-exec \
50 ${PERL} ${srctree}/scripts/generate_initcall_order.pl \
51 ${KBUILD_VMLINUX_OBJS} ${KBUILD_VMLINUX_LIBS} \
52 > .tmp_initcalls.lds
53}
54
Sami Tolvanen38e89182020-12-11 10:46:20 -080055# If CONFIG_LTO_CLANG is selected, collect generated symbol versions into
56# .tmp_symversions.lds
57gen_symversions()
58{
59 info GEN .tmp_symversions.lds
60 rm -f .tmp_symversions.lds
61
62 for o in ${KBUILD_VMLINUX_OBJS} ${KBUILD_VMLINUX_LIBS}; do
63 if [ -f ${o}.symversions ]; then
64 cat ${o}.symversions >> .tmp_symversions.lds
65 fi
66 done
67}
68
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020069# Link of vmlinux.o used for section mismatch analysis
70# ${1} output file
71modpost_link()
72{
Stephen Rothwella5967db2016-08-24 22:29:19 +100073 local objects
Sami Tolvanen38e89182020-12-11 10:46:20 -080074 local lds=""
Stephen Rothwella5967db2016-08-24 22:29:19 +100075
Nicholas Piggin6358d6e2018-02-11 00:25:03 +100076 objects="--whole-archive \
Masahiro Yamadad151e972019-01-17 09:10:04 +090077 ${KBUILD_VMLINUX_OBJS} \
Nicholas Piggin6358d6e2018-02-11 00:25:03 +100078 --no-whole-archive \
79 --start-group \
80 ${KBUILD_VMLINUX_LIBS} \
81 --end-group"
82
Sami Tolvanendc5723b2020-12-11 10:46:19 -080083 if [ -n "${CONFIG_LTO_CLANG}" ]; then
Sami Tolvanena8cccdd2020-12-11 10:46:24 -080084 gen_initcalls
85 lds="-T .tmp_initcalls.lds"
86
Sami Tolvanen38e89182020-12-11 10:46:20 -080087 if [ -n "${CONFIG_MODVERSIONS}" ]; then
88 gen_symversions
89 lds="${lds} -T .tmp_symversions.lds"
90 fi
91
Sami Tolvanendc5723b2020-12-11 10:46:19 -080092 # This might take a while, so indicate that we're doing
93 # an LTO link
94 info LTO ${1}
95 else
96 info LD ${1}
97 fi
98
Sami Tolvanen38e89182020-12-11 10:46:20 -080099 ${LD} ${KBUILD_LDFLAGS} -r -o ${1} ${lds} ${objects}
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200100}
101
Peter Zijlstra6804c1a2020-03-18 13:33:54 +0100102objtool_link()
103{
Sami Tolvanenb1a1a1a2020-04-13 16:10:13 -0700104 local objtoolcmd;
Peter Zijlstra6804c1a2020-03-18 13:33:54 +0100105 local objtoolopt;
106
Sami Tolvanenb1a1a1a2020-04-13 16:10:13 -0700107 if [ "${CONFIG_LTO_CLANG} ${CONFIG_STACK_VALIDATION}" = "y y" ]; then
108 # Don't perform vmlinux validation unless explicitly requested,
109 # but run objtool on vmlinux.o now that we have an object file.
110 if [ -n "${CONFIG_UNWINDER_ORC}" ]; then
111 objtoolcmd="orc generate"
112 fi
113
114 objtoolopt="${objtoolopt} --duplicate"
115
116 if [ -n "${CONFIG_FTRACE_MCOUNT_USE_OBJTOOL}" ]; then
117 objtoolopt="${objtoolopt} --mcount"
118 fi
119 fi
120
Peter Zijlstra6804c1a2020-03-18 13:33:54 +0100121 if [ -n "${CONFIG_VMLINUX_VALIDATION}" ]; then
Sami Tolvanenb1a1a1a2020-04-13 16:10:13 -0700122 objtoolopt="${objtoolopt} --noinstr"
123 fi
124
125 if [ -n "${objtoolopt}" ]; then
126 if [ -z "${objtoolcmd}" ]; then
127 objtoolcmd="check"
128 fi
129 objtoolopt="${objtoolopt} --vmlinux"
Peter Zijlstra6804c1a2020-03-18 13:33:54 +0100130 if [ -z "${CONFIG_FRAME_POINTER}" ]; then
131 objtoolopt="${objtoolopt} --no-fp"
132 fi
Sami Tolvanenb1a1a1a2020-04-13 16:10:13 -0700133 if [ -n "${CONFIG_GCOV_KERNEL}" ] || [ -n "${CONFIG_LTO_CLANG}" ]; then
Peter Zijlstra6804c1a2020-03-18 13:33:54 +0100134 objtoolopt="${objtoolopt} --no-unreachable"
135 fi
136 if [ -n "${CONFIG_RETPOLINE}" ]; then
137 objtoolopt="${objtoolopt} --retpoline"
138 fi
139 if [ -n "${CONFIG_X86_SMAP}" ]; then
140 objtoolopt="${objtoolopt} --uaccess"
141 fi
Peter Zijlstrae463a092021-12-04 14:43:44 +0100142 if [ -n "${CONFIG_SLS}" ]; then
143 objtoolopt="${objtoolopt} --sls"
144 fi
Peter Zijlstra6804c1a2020-03-18 13:33:54 +0100145 info OBJTOOL ${1}
Sami Tolvanenb1a1a1a2020-04-13 16:10:13 -0700146 tools/objtool/objtool ${objtoolcmd} ${objtoolopt} ${1}
Peter Zijlstra6804c1a2020-03-18 13:33:54 +0100147 fi
148}
149
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200150# Link of vmlinux
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700151# ${1} - output file
Andrii Nakryiko618916a2019-09-05 10:59:38 -0700152# ${2}, ${3}, ... - optional extra .o files
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200153vmlinux_link()
154{
Andrii Nakryiko618916a2019-09-05 10:59:38 -0700155 local output=${1}
Masahiro Yamada8f130512021-08-19 09:57:37 +0900156 local objs
157 local libs
Masahiro Yamada5df77ad2021-08-19 09:57:39 +0900158 local ld
159 local ldflags
160 local ldlibs
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200161
Linus Torvaldsd7b08272019-09-20 08:36:47 -0700162 info LD ${output}
163
Andrii Nakryiko618916a2019-09-05 10:59:38 -0700164 # skip output file argument
165 shift
166
Masahiro Yamada8f130512021-08-19 09:57:37 +0900167 if [ -n "${CONFIG_LTO_CLANG}" ]; then
168 # Use vmlinux.o instead of performing the slow LTO link again.
169 objs=vmlinux.o
170 libs=
171 else
172 objs="${KBUILD_VMLINUX_OBJS}"
173 libs="${KBUILD_VMLINUX_LIBS}"
174 fi
175
Masahiro Yamada5df77ad2021-08-19 09:57:39 +0900176 if [ "${SRCARCH}" = "um" ]; then
177 wl=-Wl,
178 ld="${CC}"
179 ldflags="${CFLAGS_vmlinux}"
180 ldlibs="-lutil -lrt -lpthread"
181 else
182 wl=
183 ld="${LD}"
184 ldflags="${KBUILD_LDFLAGS} ${LDFLAGS_vmlinux}"
185 ldlibs=
186 fi
187
188 ldflags="${ldflags} ${wl}--script=${objtree}/${KBUILD_LDS}"
189
Kees Cookaf73d782020-03-03 18:18:34 -0800190 # The kallsyms linking does not need debug symbols included.
191 if [ "$output" != "${output#.tmp_vmlinux.kallsyms}" ] ; then
Masahiro Yamada5df77ad2021-08-19 09:57:39 +0900192 ldflags="${ldflags} ${wl}--strip-debug"
Kees Cookaf73d782020-03-03 18:18:34 -0800193 fi
194
Rasmus Villemoes5cc12472021-03-05 10:27:07 +0100195 if [ -n "${CONFIG_VMLINUX_MAP}" ]; then
Masahiro Yamada5df77ad2021-08-19 09:57:39 +0900196 ldflags="${ldflags} ${wl}-Map=${output}.map"
Rasmus Villemoes5cc12472021-03-05 10:27:07 +0100197 fi
198
Masahiro Yamada5df77ad2021-08-19 09:57:39 +0900199 ${ld} ${ldflags} -o ${output} \
200 ${wl}--whole-archive ${objs} ${wl}--no-whole-archive \
201 ${wl}--start-group ${libs} ${wl}--end-group \
202 $@ ${ldlibs}
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200203}
204
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700205# generate .BTF typeinfo from DWARF debuginfo
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700206# ${1} - vmlinux image
207# ${2} - file to dump raw BTF data into
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700208gen_btf()
209{
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700210 local pahole_ver
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700211
Andrii Nakryiko581b31c2019-05-05 17:10:33 -0700212 if ! [ -x "$(command -v ${PAHOLE})" ]; then
Chris Down2a67a6c2020-01-22 00:01:10 +0000213 echo >&2 "BTF: ${1}: pahole (${PAHOLE}) is not available"
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700214 return 1
Andrii Nakryiko581b31c2019-05-05 17:10:33 -0700215 fi
216
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700217 pahole_ver=$(${PAHOLE} --version | sed -E 's/v([0-9]+)\.([0-9]+)/\1\2/')
Lorenz Bauer21a85bd2020-06-08 10:42:57 +0100218 if [ "${pahole_ver}" -lt "116" ]; then
219 echo >&2 "BTF: ${1}: pahole version $(${PAHOLE} --version) is too old, need at least v1.16"
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700220 return 1
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700221 fi
222
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700223 vmlinux_link ${1}
Kees Cookaf73d782020-03-03 18:18:34 -0800224
225 info "BTF" ${2}
Jiri Olsa9741e072021-10-29 14:57:29 +0200226 LLVM_OBJCOPY="${OBJCOPY}" ${PAHOLE} -J ${PAHOLE_FLAGS} ${1}
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700227
Fangrui Song90ceddc2020-03-18 15:27:46 -0700228 # Create ${2} which contains just .BTF section but no symbols. Add
229 # SHF_ALLOC because .BTF will be part of the vmlinux image. --strip-all
230 # deletes all symbols including __start_BTF and __stop_BTF, which will
231 # be redefined in the linker script. Add 2>/dev/null to suppress GNU
232 # objcopy warnings: "empty loadable segment detected at ..."
233 ${OBJCOPY} --only-section=.BTF --set-section-flags .BTF=alloc,readonly \
234 --strip-all ${1} ${2} 2>/dev/null
235 # Change e_type to ET_REL so that it can be used to link final vmlinux.
236 # Unlike GNU ld, lld does not allow an ET_EXEC input.
237 printf '\1' | dd of=${2} conv=notrunc bs=1 seek=16 status=none
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700238}
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200239
Masahiro Yamada08beb662020-09-25 00:45:46 +0900240# Create ${2} .S file with all symbols from the ${1} object file
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200241kallsyms()
242{
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200243 local kallsymopt;
244
245 if [ -n "${CONFIG_KALLSYMS_ALL}" ]; then
James Hogan6895f972012-09-06 22:11:25 +0100246 kallsymopt="${kallsymopt} --all-symbols"
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200247 fi
248
Ard Biesheuvel4d5d5662016-03-15 14:58:12 -0700249 if [ -n "${CONFIG_KALLSYMS_ABSOLUTE_PERCPU}" ]; then
Rusty Russellc6bda7c2014-03-17 14:05:46 +1030250 kallsymopt="${kallsymopt} --absolute-percpu"
251 fi
252
Ard Biesheuvel2213e9a2016-03-15 14:58:19 -0700253 if [ -n "${CONFIG_KALLSYMS_BASE_RELATIVE}" ]; then
254 kallsymopt="${kallsymopt} --base-relative"
255 fi
256
Masahiro Yamada08beb662020-09-25 00:45:46 +0900257 info KSYMS ${2}
258 ${NM} -n ${1} | scripts/kallsyms ${kallsymopt} > ${2}
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200259}
260
Kees Cook8959e392019-08-13 08:15:32 -0700261# Perform one step in kallsyms generation, including temporary linking of
262# vmlinux.
263kallsyms_step()
264{
265 kallsymso_prev=${kallsymso}
Kees Cookaf73d782020-03-03 18:18:34 -0800266 kallsyms_vmlinux=.tmp_vmlinux.kallsyms${1}
267 kallsymso=${kallsyms_vmlinux}.o
Masahiro Yamada08beb662020-09-25 00:45:46 +0900268 kallsyms_S=${kallsyms_vmlinux}.S
Kees Cook8959e392019-08-13 08:15:32 -0700269
Linus Torvaldsd7b08272019-09-20 08:36:47 -0700270 vmlinux_link ${kallsyms_vmlinux} "${kallsymso_prev}" ${btf_vmlinux_bin_o}
Masahiro Yamada08beb662020-09-25 00:45:46 +0900271 kallsyms ${kallsyms_vmlinux} ${kallsyms_S}
272
273 info AS ${kallsyms_S}
274 ${CC} ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS} \
275 ${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} \
276 -c -o ${kallsymso} ${kallsyms_S}
Kees Cook8959e392019-08-13 08:15:32 -0700277}
278
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200279# Create map file with all symbols from ${1}
280# See mksymap for additional details
281mksysmap()
282{
283 ${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
284}
285
Shile Zhang10916702019-12-04 08:46:31 +0800286sorttable()
Linus Torvalds1347a2ce2012-05-28 10:32:28 -0700287{
Shile Zhang10916702019-12-04 08:46:31 +0800288 ${objtree}/scripts/sorttable ${1}
Linus Torvalds1347a2ce2012-05-28 10:32:28 -0700289}
290
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200291# Delete output files in case of error
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200292cleanup()
293{
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700294 rm -f .btf.*
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200295 rm -f .tmp_System.map
Sami Tolvanena8cccdd2020-12-11 10:46:24 -0800296 rm -f .tmp_initcalls.lds
Sami Tolvanen38e89182020-12-11 10:46:20 -0800297 rm -f .tmp_symversions.lds
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200298 rm -f .tmp_vmlinux*
299 rm -f System.map
300 rm -f vmlinux
Rasmus Villemoes5cc12472021-03-05 10:27:07 +0100301 rm -f vmlinux.map
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200302 rm -f vmlinux.o
Rasmus Villemoes0b956e22021-03-05 11:02:12 +0100303 rm -f .vmlinux.d
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200304}
305
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200306# Use "make V=1" to debug this script
307case "${KBUILD_VERBOSE}" in
308*1*)
309 set -x
310 ;;
311esac
312
313if [ "$1" = "clean" ]; then
314 cleanup
315 exit 0
316fi
317
318# We need access to CONFIG_ symbols
Masahiro Yamada94cf8ac2019-03-08 14:49:10 +0900319. include/config/auto.conf
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200320
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200321# Update version
322info GEN .version
Masahiro Yamada278ae602017-09-22 14:31:13 +0900323if [ -r .version ]; then
324 VERSION=$(expr 0$(cat .version) + 1)
325 echo $VERSION > .version
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200326else
Masahiro Yamada278ae602017-09-22 14:31:13 +0900327 rm -f .version
328 echo 1 > .version
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200329fi;
330
331# final build of init/
Masahiro Yamada083bc0e2020-02-11 05:06:34 +0900332${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init need-builtin=1
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200333
Nicholas Pigginabac4c82016-11-24 03:41:43 +1100334#link vmlinux.o
Nicholas Pigginabac4c82016-11-24 03:41:43 +1100335modpost_link vmlinux.o
Peter Zijlstra6804c1a2020-03-18 13:33:54 +0100336objtool_link vmlinux.o
Nicholas Pigginabac4c82016-11-24 03:41:43 +1100337
338# modpost vmlinux.o to check for section mismatches
Masahiro Yamadaa7215882019-07-31 00:59:02 +0900339${MAKE} -f "${srctree}/scripts/Makefile.modpost" MODPOST_VMLINUX=1
Nicholas Pigginabac4c82016-11-24 03:41:43 +1100340
Alexey Gladkov898490c2019-04-29 18:11:14 +0200341info MODINFO modules.builtin.modinfo
342${OBJCOPY} -j .modinfo -O binary vmlinux.o modules.builtin.modinfo
Masahiro Yamada8b41fc42019-12-19 17:33:29 +0900343info GEN modules.builtin
344# The second line aids cases where multiple modules share the same object.
345tr '\0' '\n' < modules.builtin.modinfo | sed -n 's/^[[:alnum:]:_]*\.file=//p' |
346 tr ' ' '\n' | uniq | sed -e 's:^:kernel/:' -e 's/$/.ko/' > modules.builtin
Alexey Gladkov898490c2019-04-29 18:11:14 +0200347
Andrii Nakryiko7fd78562019-08-13 11:54:42 -0700348btf_vmlinux_bin_o=""
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700349if [ -n "${CONFIG_DEBUG_INFO_BTF}" ]; then
Kees Cookaf73d782020-03-03 18:18:34 -0800350 btf_vmlinux_bin_o=.btf.vmlinux.bin.o
351 if ! gen_btf .tmp_vmlinux.btf $btf_vmlinux_bin_o ; then
Stanislav Fomichevda5fb182019-11-27 08:14:10 -0800352 echo >&2 "Failed to generate BTF for vmlinux"
353 echo >&2 "Try to disable CONFIG_DEBUG_INFO_BTF"
354 exit 1
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700355 fi
356fi
357
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200358kallsymso=""
Kees Cook8959e392019-08-13 08:15:32 -0700359kallsymso_prev=""
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200360kallsyms_vmlinux=""
361if [ -n "${CONFIG_KALLSYMS}" ]; then
362
363 # kallsyms support
364 # Generate section listing all symbols and add it into vmlinux
365 # It's a three step process:
Hui Su2216cf62021-10-08 19:24:38 +0800366 # 1) Link .tmp_vmlinux.kallsyms1 so it has all symbols and sections,
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200367 # but __kallsyms is empty.
368 # Running kallsyms on that gives us .tmp_kallsyms1.o with
369 # the right size
Hui Su2216cf62021-10-08 19:24:38 +0800370 # 2) Link .tmp_vmlinux.kallsyms2 so it now has a __kallsyms section of
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200371 # the right size, but due to the added section, some
372 # addresses have shifted.
Hui Su2216cf62021-10-08 19:24:38 +0800373 # From here, we generate a correct .tmp_vmlinux.kallsyms2.o
Nicholas Piggin7e2b37c2016-11-24 03:41:37 +1100374 # 3) That link may have expanded the kernel image enough that
375 # more linker branch stubs / trampolines had to be added, which
376 # introduces new names, which further expands kallsyms. Do another
377 # pass if that is the case. In theory it's possible this results
378 # in even more stubs, but unlikely.
379 # KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
380 # other bugs.
381 # 4) The correct ${kallsymso} is linked into the final vmlinux.
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200382 #
383 # a) Verify that the System.map from vmlinux matches the map from
384 # ${kallsymso}.
385
Kees Cook8959e392019-08-13 08:15:32 -0700386 kallsyms_step 1
387 kallsyms_step 2
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200388
Nicholas Piggin7e2b37c2016-11-24 03:41:37 +1100389 # step 3
Kees Cook8959e392019-08-13 08:15:32 -0700390 size1=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso_prev})
391 size2=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso})
Nicholas Piggin7e2b37c2016-11-24 03:41:37 +1100392
393 if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
Kees Cook8959e392019-08-13 08:15:32 -0700394 kallsyms_step 3
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200395 fi
396fi
397
Linus Torvaldsd7b08272019-09-20 08:36:47 -0700398vmlinux_link vmlinux "${kallsymso}" ${btf_vmlinux_bin_o}
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700399
Jiri Olsac9a0f3b2020-07-11 23:53:24 +0200400# fill in BTF IDs
Jiri Olsa017dab32020-09-23 20:57:34 +0200401if [ -n "${CONFIG_DEBUG_INFO_BTF}" -a -n "${CONFIG_BPF}" ]; then
402 info BTFIDS vmlinux
403 ${RESOLVE_BTFIDS} vmlinux
Jiri Olsac9a0f3b2020-07-11 23:53:24 +0200404fi
405
Yinan Liu72b39422021-12-12 19:33:58 +0800406info SYSMAP System.map
407mksysmap vmlinux System.map
408
Shile Zhang10916702019-12-04 08:46:31 +0800409if [ -n "${CONFIG_BUILDTIME_TABLE_SORT}" ]; then
410 info SORTTAB vmlinux
Shile Zhangf14bf6a2019-12-04 08:46:33 +0800411 if ! sorttable vmlinux; then
412 echo >&2 Failed to sort kernel tables
413 exit 1
414 fi
Linus Torvalds1347a2ce2012-05-28 10:32:28 -0700415fi
416
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200417# step a (see comment above)
418if [ -n "${CONFIG_KALLSYMS}" ]; then
419 mksysmap ${kallsyms_vmlinux} .tmp_System.map
420
421 if ! cmp -s System.map .tmp_System.map; then
Michal Marek5369f552012-07-07 23:04:40 +0200422 echo >&2 Inconsistent kallsyms data
Michal Marek367e43c2012-08-10 11:55:11 +0200423 echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200424 exit 1
425 fi
426fi
Rasmus Villemoes0b956e22021-03-05 11:02:12 +0100427
428# For fixdep
429echo "vmlinux: $0" > .vmlinux.d